//
//       filename: F2PSCN6.POV
//
//       Transparent triangle and plane
//
//       by David Grossman 
//
//       The following texture's filter values were manually
//        changed to 1 ( the next version of frct2pov will
//        automatically assign filter values if specified )

//
//       This Mandelbrot texture include file was created by
//       Fractint to POV-Ray v0.5
//
//       File name "cafsampl.inc"
//
//       Texture name "chaos_and_fractals"
//       Converted from the manual input parameters:
//       xc=-0.7454285 , yc=0.1130089 , width=6e-06
//       Color Map converted from "fire.map"
//       Maximum error in conversion = 4
//
//       updated: Sun Jan 02 01:57:20 1994
//

#declare chaos_and_fractals =
     pigment { mandel 32640 frequency 128 phase 0
     color_map {
          [ 0 color rgbf < 0.3174603, 0.01587302, 0.01587302, 1 > ]
          [ 0.05882353 color rgbf < 0.7142857, 0.04761905, 0.03174603, 1 > ]
          [ 0.1882353 color rgbf < 0.9206349, 0.2222222, 0.07936508, 1 > ]
          [ 0.2705882 color rgbf < 0.9365079, 0.3650794, 0.1269841, 1 > ]
          [ 0.282353 color rgbf < 0.968254, 0.3968254, 0.1428571, 1 > ]
          [ 0.5058824 color rgbf < 0.984127, 0.6984127, 0.3015873, 1 > ]
          [ 0.509804 color rgbf < 1, 0.7142857, 0.3174603, 1 > ]
          [ 0.5882353 color rgbf < 1, 0.4444444, 0.04761905, 1 > ]
          [ 0.6 color rgbf < 1, 0.4126984, 0, 1 > ]
          [ 0.7764706 color rgbf < 0.8253968, 0, 0, 1 > ]
          [ 0.8509804 color rgbf < 0.6031746, 0.01587302, 0.01587302, 1 > ]
          [ 0.8862745 color rgbf < 0.4761905, 0.0952381, 0.0952381, 1 > ]
          [ 0.9490196 color rgbf < 0, 0, 0, 10 > ]
          [ 1 color rgbf < 0.3174603, 0.01587302, 0.01587302, 1 > ]  }
               translate < 0.7454285, -0.1130089, 0 >
               scale < 333333.333333333, 333333.333333333, 1 >
             }

camera   {  location < -2, 6, 8 >
            direction < 0, 0, 2.2 >
            up < 0, 1, 0 >        // y is up
            right < -4/3, 0, 0 >  // right handed system
            look_at < -.6, 1.3, 0 >
         }
         
         
object   {  triangle { < 2,2,-2 >, < -2,3,-1 >, < .5,1.5,2.5 > }
            texture  {  chaos_and_fractals
                        finish   {  ambient .2 diffuse .2 refraction 1 } rotate -90*x }  }

object   {  plane {  y,0 }
            texture  {  pigment { color rgb < 1,1,1 > }
                        finish   {  ambient .3 diffuse .7 } rotate -90*x scale 2 }   }

object   {  light_source   {  < 10, 30, 20 > color rgb < 1, 1, 1 > } }
                                    
                                    
                                    
                                    
                                    
