#ifndef GLOBALS_H
#define GLOBALS_H

	/* Delay before drawing splines when modifying:		*/
extern unsigned long	Delay_Draw_Seconds;
extern unsigned long	Delay_Draw_Micros;

	/* Flag set to TRUE when quitting program:		*/
extern Boolean_T	Quit_Flag;

	/* Flag set to non-zero when redraw wanted:		*/
extern long		Redraw_Mask;

	/* Current perspective view rotation vector (degrees):	*/
extern Vector_T		Rotation_Vector;

	/* Current position of origin:				*/
extern Vector_T		Origin;

	/* The 'state' of the program:				*/
extern State_T		State;

	/* The current view rotation matrix:			*/
extern Matrix_T		M_Rotation;

	/* The inverse of M_Rotation:				*/
extern Matrix_T		M_InvRotation;

	/* Array containing points:				*/
extern Point_T		Points[];

	/* Array containing saved points:			*/
extern Point_T		Saved_Points[];

	/* Array containing splines:				*/
extern Spline_T		*Splines;

	/* TRUE if in group mode:            			*/
extern Boolean_T	Group_Mode;

	/* TRUE if some points are hidden:     			*/
extern Boolean_T	Points_Hidden;

	/* Current selected view, knot, spline & point:		*/
extern short		Select_View_Id;
extern Knot_T		*Select_Knot;
extern Spline_T		*Select_Spline;
extern short		Select_Point_Id;

	/* Current world position:				*/
extern Vector_T		Current_Pos;

	/* Mask defining what to be drawn:			*/
extern long		What_Mask;

	/* Resolution when drawing splines:			*/
extern short		Spline_Resolution;

	/* Resolution when tesselating patches:			*/
extern short		Patch_Resolution;

	/* True if SIPP should use backface culling: 		*/
extern Boolean_T	Backface_Culling;

	/* Width & Height of screen:				*/
extern short		Screen_Width;
extern short   		Screen_Height;

	/* Current aspect ratio of screen:			*/
extern double		Aspect_Ratio;

	/* Current scale factors:				*/
extern double		X_Scale_Factor;
extern double		Y_Scale_Factor;

	/* Current max select distance:				*/
extern double		Max_Dist;

	/* World coordinate of point in center of views:	*/
extern Vector_T 	Offset;

	/* Size of grid:					*/
extern double		Grid_Size;

	/* Should grid be shown?				*/
extern Boolean_T	Grid_Active;

	/* Should we snap to the grid?				*/
extern Boolean_T  	Grid_Snap_Active;

	/* Rendering mode:					*/
extern Rendering_Mode_T	Rendering_Mode;

#endif
