/* :ts=8 */
/************************************************************************/
/*                                                                      */
/* This file contains the main program for ICoons.			*/
/*                                                                      */
/* ICoons may be distributed under the terms  of  the  GNU  General  	*/
/* Public License,  this  license  has been included in file COPYING 	*/
/* found in this distribution.						*/
/*                                                                      */
/* Author: Helge E. Rasmussen (her@compel.dk).				*/
/*                                                                      */
/************************************************************************/

#include  <stdio.h>
#include <string.h>
#include <ctype.h>

#include "general.h"
#include "globals.h"
#include "intui.h"
#include "file.h"
#include "spl_math.h"
#include "spl_util.h"
#include "spl_gfx.h"
#include "normal.h"


main()
/************************************************************************/
/*                                                                      */
/*				Main program.				*/
/*                                                                      */
/************************************************************************/
{

	OpenStuff();

	Config_File_Read(Default_Config_File_Name);

	Set_Mode_Normal();
	Transformation_Init();
	Splines_Init();
	Draw_All(What_All);

	do {

	    Check_Event();

	} while (! Quit_Flag);


	Finish();

} /* main */
