/* :ts=8 */
#ifndef SPL_GFX_H
#define SPL_GFX_H

/* Usage of pens:						*/
#define Pen_Background		0
#define Pen_Plane		8	/* Don't modify this one! */
#define Pen_Grid		3

#define Pen_Axis_X		4
#define Pen_Axis_Y		5
#define Pen_Axis_Z		6

#define Pen_Segment		1	/* Unselected			*/
#define Pen_Segment_Selected	4	/* Selected			*/

#define Pen_Knot		7	/* Unselected			*/
#define Pen_Knot_Primary	5	/* Primary selection		*/
#define Pen_Knot_Selected	6	/* Group selection		*/

void Transformation_Init(void);

void Set_Offset(Vector_T Pos, short View_Id);
void Move_Offset(short Direction, short View_Id);

void Snap_To_Grid(Vector_T Pos);

short Screen_To_World(int Screen_X, int Screen_Y, Vector_T Pos);

void World_To_Screen(Vector_T Pos, short *X0, short *Y0, 
				   short *X1, short *Y1, 
				   short *X2, short *Y2);
void World_To_Persp(Vector_T Pos, short *X, short *Y);

void Unmark_All(void);
void Mark_Selected_Segments(void);
void Mark_Connected_Segments(short Point_Id);

void Compute_Segment(Spline_T *Spline, Knot_T *Knot);
void Compute_Marked_Segments(void);
void Compute_Spline(Spline_T *Spline);
void Compute_Splines(void);

void Draw_Segment(Spline_T *Spline, Knot_T *Knot, int Color, long What);
void Draw_Marked_Segments(Draw_Mode_T Mode, long What);

void Draw_Spline(Spline_T *SPline, Draw_Mode_T Mode, long What);
void Draw_Splines(Draw_Mode_T Mode, long What);

void Draw_Knot(Spline_T *Spline, Knot_T *Knot, Draw_Mode_T Mode, long What);
void Draw_Knots(Draw_Mode_T Mode, long What);

void Draw_Origin(Draw_Mode_T Mode, long What);
void Draw_Box(Vector_T Min_Pos, Vector_T Max_Pos, Vector_T R_Vector,
					Draw_Mode_T Mode, long What);
void Draw_Grid(long What);
void Draw_All(long What);

#endif
