/* :ts=8 */
#ifndef SPL_MATH_H
#define SPL_MATH_H

void Matrix_Mult( Matrix_T MRes, Matrix_T M1, Matrix_T M2);
void Matrix4_Mult( Matrix4_T MRes, Matrix4_T M1, Matrix4_T M2);
void Matrix_VMult(Vector_T VRes, Vector_T V, Matrix_T M);
void Matrix4_VMult(Vector4_T VRes, Vector4_T V, Matrix4_T M);
void Matrix_MultV(Vector_T VRes, Matrix_T M, Vector_T V);
void Compute_Rotation_Matrix(Matrix_T R_Matrix, Vector_T Rot_Vector);
void Compute_Inverse_Rotation_Matrix(Matrix_T R_Matrix, Vector_T Rot_Vector);
void Precompute_Kochanek_Bartels(Matrix4_T Mres, Spline_T *Spline,
				 Knot_T *Knot);
void Compute_Position(Vector4_T Vres, double T, Matrix4_T M_Precomp);

#endif
