/* :ts=8 */
#ifndef SPL_UTIL_H
#define SPL_UTIL_H

#define   Is_Point_Id_Ok(P) ((P) >= 0)

void      Splines_Init(void);

void 	  Set_Origin(Vector_T New_Origin);

Boolean_T Get_Bounding_Box(Vector_T Min_Pos, Vector_T Max_Pos);
Boolean_T Get_Select_Bounding_Box(Vector_T Min_Pos, Vector_T Max_Pos);

void	  Points_Save();
void	  Points_Restore();

void	  Points_Move(Vector_T Distance);
void	  Points_Scale(double Scale_Factor, Boolean_T Do_Scale_X, 
			Boolean_T Do_Scale_Y, Boolean_T Do_Scale_Z);
void	  Points_Rotate(double Angle, short Axis);
void	  Points_Set_Tension(double Tension);
void	  Points_Set_Bias(double Bias);
void	  Points_Set_Continuity(double Continuity);

void 	  Point_Move(short Point_Id, Vector_T Pos);
short 	  Point_New(Vector_T Pos);
short 	  Point_Find(Vector_T Pos, short View_Id);

void	  Knot_Insert(Spline_T *Spline, Knot_T *Knot, Knot_T *New_Knot);
void	  Knot_Remove(Spline_T *Spline, Knot_T *Knot);
Knot_T	  *Knot_New(Spline_T *Spline, Knot_T *Knot);
void	  Knot_Free(Spline_T *Spline, Knot_T *Knot);
Knot_T 	  *Knot_Add(Spline_T *Spline, Knot_T *Knot, Vector_T Pos);
void 	  Knot_Delete(Spline_T *Spline, Knot_T *Knot);

Spline_T  *Spline_New(void);
void 	  Spline_Free(Spline_T *Spline);
void 	  Spline_Loop(Spline_T *Spline, Boolean_T Loop);
Spline_T  *Spline_Add(Vector_T Pos);
Spline_T  *Spline_Cut(Spline_T *Spline, Knot_T *Knot);
void	  Spline_Reverse_Knots(Spline_T *Spline);



Boolean_T Splines_Connect(short View_Id, Spline_T *Spline, Knot_T *Knot);
Boolean_T Splines_Combine(short View_Id, Spline_T *Spline, Knot_T *Knot);
void 	  Splines_Disconnect(short Point_Id);

void 	  Deselect_All(void);
void 	  Toggle_Select_All(void);
Boolean_T Select_Knot_From_Group();
void 	  Select_Point(short Point_Id);
void 	  Select_Next_Knot(void);
void 	  Toggle_Select_Spline(Spline_T *Spline);
void 	  Select_Area(short View_Id, Vector_T Pos1, Vector_T Pos2);

void 	  Hide_Selected_Points(void);
void 	  Hide_Unselected_Points(void);
void 	  Show_All_Points(void);

#endif
