/*
 *
 * $VER: jpeg_gui 1.0 (10/10/91) 18:30:30
 *
 * Simple GUI face for the Amiga jpeg utils
 * This code is:  1991, James Cates
 *
 * redistribute freely at no direct profit
 *
 */

signal on error
signal on syntax

check = addlib('rexxsupport.library',0,-30,0) 
check = addlib('rexxarplib.library',0,-30,0)   

proggy	= "JPEG"
screen  = 'Workbench'
jpg_out = ""
jpg_in  = ""
iff_out = ""
iff_in  = ""
wide    = 250
high    = 150

from_iff_ppm  = ""
from_jpg_ppm  = ""

call midscreen(wide,high)

about_txt = "JPeg GUI"

call openhost(proggy)

dir  = ""
gadx = 10
gady = 16

call addgadget(proggy,gadx,(gady+(1*13)),'gad_to_jp',"Write JPEG  ",to_jpg)
call addgadget(proggy,gadx,(gady+(3*13)),'gad_to_24',"Write IFF 24",to_iff)
call addgadget(proggy,gadx,(gady+(8*12)),'gad_qual',"\ Quality \",con_qual)

prct = print_prct(100)
c_opts = '-Q' || prct
d_opts  = ""
call print_iff()
call print_jpg()

menu	= "JPeg"

m_txt1	= "JPeg GUI"
m_txt2	= "By: Jim Cates"
m_txt3	= " 1991, Babaloo Software"
call addmenu(proggy,menu)
call additem(proggy,"QUIT",'ABORT','Q',,)
call additem(proggy,"ABOUT ",'','',,)
	call addsubitem(proggy,m_txt1,'NULL1')
	call addsubitem(proggy,m_txt2,'NULL2')
	call addsubitem(proggy,m_txt3,'NULL3')

call openport(JPEGPORT)

do forever
	call delay(50)
	if showlist('p',JPEGPORT) then leave
end

chill:
do forever
   	t = waitpkt(JPEGPORT)

	do ff = 1
		p = getpkt(JPEGPORT)
      		if p == NULL() then leave ff
      		command = getarg(p)
      		t = reply(p,1)

		    parse var command

	      	if command = ABORT | command = CLOSEWINDOW then do
			call postmsg()
			call removemenu(proggy)
			call quit(proggy)
			exit()
         	end
		if command = to_jpg then do
			in = myreq(iff_in,i_iff)
				parse var in iff_in infile
				call check_iff(infile)
			out = myreq(jpg_out,o_jpg)
				parse var out jpg_out outfile
			call write_jpg(iff_in,jpg_out,infile,outfile)
		end
		if command = to_iff then do
			in = myreq(jpg_in,i_jpg)
				parse var in jpg_in infile
				call check_jpg(infile)
			out = myreq(iff_out,o_iff)
				parse var out iff_out outfile
			call write_iff(jpg_in,iff_out,infile,outfile)
		end
		if command = con_qual then do
			prct = (prct + 25)
			prct = print_prct(prct)
			c_opts = '-Q' || prct
		end
	end
end
/*
 * no need to exit, loop never really ends
 */

openhost:
parse arg hostname
if ~showlist('p', hostname) then ,
    address AREXX "'call createhost("hostname", JPEGPORT)'"

do i = 1 to 10
   if ~showlist('p', hostname) then call delay 20
   else leave i
end

idcmp = 'CLOSEWINDOW+GADGETUP+MENUPICK+VANILLAKEY'
flags = 'WINDOWCLOSE+WINDOWDEPTH+WINDOWDRAG+BACKFILL+ACTIVATE'

call setreqcolor(proggy,BACK,0)
call setreqcolor(proggy,BLOCK,1)
call setreqcolor(proggy,DETAIL,3)

call openwindow(hostname,xpos,ypos,wide,high,idcmp,flags,"Jpeg")
return

error:
syntax:
call postmsg(10,20,errortext(RC) || "\in line # " || SIGL)
call delay(50)
call postmsg()
if showlist('p',JPEGPORT) then do
	call removemenu(proggy)
	call quit(proggy)
end
exit

midscreen:
parse arg wide, high
xpos = ((screencols() / 2) - (wide / 2))
ypos = ((screenrows() / 2) - (high / 2))
return

write_jpg:
parse arg iff_in, jpg_out, infile, outfile
from_iff_ppm = 'ram:to_jpg.temp.ppm'
if iff_in = '' then call io_err(iff)
if jpg_out = '' then call io_err(jpg)
  call clean_fill()
  call print_prct(prct)
  call print_iff(iff_in)
  call print_jpg(jpg_out)
    call postmsg(xpos,40,"\Writing temp. ppm file\")
compress = '24toppm >nil: ' || infile || ' ' || from_iff_ppm
  address command compress
    call postmsg(xpos,40,"\Writing jpeg file\")
compress = 'cjpeg ' || c_opts from_iff_ppm || ' >'outfile
  address command compress
    call postmsg(xpos,40,"\Cleaning up\")
cleanup = 'delete >nil: ' || from_iff_ppm
  address command cleanup
    call postmsg()
return

write_iff:
parse arg jpg_in, iff_out, infile, outfile
from_jpg_ppm = 'ram:to_iff.temp.ppm'
if jpg_in = '' then call io_err(jpg)
if iff_out = '' then call io_err(iff)
  call clean_fill()
  call print_prct(prct)
  call print_iff(iff_out)
  call print_jpg(jpg_in)
    call postmsg(xpos,40,"\Writing temp. ppm file\")
compress = 'djpeg ' || d_opts infile || ' >'from_jpg_ppm
  address command compress
    call postmsg(xpos,40,"\Writing iff file\")
compress = 'ppmto24 >nil: ' || from_jpg_ppm outfile
  address command compress
    call postmsg(xpos,40,"\Cleaning up\")
cleanup = 'delete >nil: ' || from_jpg_ppm
  address command cleanup
    call postmsg()
return

print_prct:
parse arg prct
if prct > 100 then prct = 25
p_string = prct
if (length(p_string) < 3) then p_string = p_string || ' '
call move(proggy,100,(gady+(9*12)+5))
call setapen(proggy,1)
call text(proggy,p_string || "%")
return(prct)

print_iff:
parse arg iff_file
head = "IFF  > "
if iff_file = "" then iff_file = "none"
call setapen(proggy,1)
call move(proggy,10,gady+(5*12)+8)
call text(proggy,head || iff_file)
return

print_jpg:
parse arg jpg_file
head = "JPEG > "
if jpg_file = "" then jpg_file = "none"
call setapen(proggy,1)
call move(proggy,10,gady+(6*12)+13)
call text(proggy,head || jpg_file)
return

io_err:
parse arg filetype
select
	when filetype = jpg then type = "No jpeg file open"
	when filetype = iff then type = "No iff24 file open"
end
call request(50,50,"I/O error\" || type,,"oops!")
call chill()

myreq:
parse arg name, mode
if dir 	= "" then dir = pragma('d')
select
	when mode = i_jpg then rtitle = "Select JPEG file to load"
	when mode = i_iff then rtitle = "Select IFF file to load"
	when mode = o_jpg then rtitle = "Enter JPEG file to save"
	when mode = o_iff then rtitle = "Enter IFF file to save"
	otherwise nop
end
opt  = "DOARP"      /* use DOARP if you run fr_bypass */
file = getfile(170,55,dir,name,rtitle,,opt,,330,330,)
if file = "" then call chill()
name = chop(file)
call pragma(d,dir)
return(name file)

chop:
parse arg file
if index(file,"/") ~= '0' then do
        set = lastpos("/",file)
        dir = left(file,(set - 1))
		name = left(substr(file,(set + 1),length(file)),21)
		call pragma(d,dir)
	return(name)
end
if index(file,":") ~= '0' then do
        set = lastpos(":",file)
        dir = left(file,(set))
		name = left(substr(file,(set + 1),length(file)),21)
		call pragma(d,dir)
	return(name)
end
return(name)

clean_fill:
call setapen(proggy,0)
call rectfill(proggy,5,16,(wide - 5),(high - 5))
call refreshgadgets(proggy)
call print_prct(prct)
return

check_iff:
parse arg check_file
check_file = compress(check_file)

call open(in,check_file,r)

call seek(in,8,b)
  form = readch(in,4)
call seek(in,28,b)
  planes = c2d(readch(in,1))
call close(in)

if form ~= 'ILBM' | planes ~= 24 then do
  call request(50,50,'File is not an IFF24',,'Oops!',)
  call chill()
end
return

check_jpg:
parse arg check_file
check_file = compress(check_file)

call open(in,check_file,r)

call seek(in,6,b)
  form = readch(in,4)
call close(in)

if form ~= 'JFIF' then do
  call request(50,50,'That is not a JPEG file',,'Oops!',)
  call chill()
end
return
