/*
 * rotate.h
 *
 * Copyright (C) 1989, 1991, Craig E. Kolb
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 * 
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 * rotate.h,v 4.1 1994/08/09 07:55:01 explorer Exp
 *
 * rotate.h,v
 * Revision 4.1  1994/08/09  07:55:01  explorer
 * Bump version to 4.1
 *
 * Revision 1.1.1.1  1994/08/08  04:52:01  explorer
 * Initial import.  This is a prerelease of 4.0.6enh3, or 4.1 possibly.
 *
 * Revision 4.0  91/07/17  14:31:26  kolb
 * Initial version.
 * 
 */
#ifndef ROTATE_H
#define ROTATE_H

#define TransRotateCreate()		TransCreate((TransRef)RotateCreate(), RotateMethods())

#define TransRotateSetX(t, v)		TransAssoc(t, &((Rotate *)t->tr)->x, v)
#define TransRotateSetY(t, v)		TransAssoc(t, &((Rotate *)t->tr)->y, v)
#define TransRotateSetZ(t, v)		TransAssoc(t, &((Rotate *)t->tr)->z, v)
#define TransRotateSetTheta(t, v)	TransAssoc(t, &((Rotate *)t->tr)->theta, v)

typedef struct {
	Float x, y, z, theta;
} Rotate;

extern Rotate *RotateCreate();
extern TransMethods *RotateMethods();
extern void RotatePropagate();

#endif /* ROTATE_H */
