/*
 * csg.h
 *
 * Copyright (C) 1989, 1991, Craig E. Kolb
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 * csg.h,v 4.1 1994/08/09 07:58:22 explorer Exp
 *
 * csg.h,v
 * Revision 4.1  1994/08/09  07:58:22  explorer
 * Bump version to 4.1
 *
 * Revision 1.1.1.1  1994/08/08  04:52:08  explorer
 * Initial import.  This is a prerelease of 4.0.6enh3, or 4.1 possibly.
 *
 * Revision 4.0  91/07/17  14:37:06  kolb
 * Initial version.
 * 
 */
#ifndef CSG_H
#define CSG_H

#define GeomCsgCreate(t)	GeomCreate((GeomRef)CsgCreate(t), CsgMethods())

/*
 * CSG (Constructive Solid Geometry)
 */
#define CSG_UNION	0
#define CSG_INTERSECT	1
#define CSG_DIFFERENCE	2

typedef struct Csg {
	char operator;			/* Union, Intersect, or Difference */
	struct Geom *obj1, *obj2;
	int (*intmeth)();		/* Intersection method. */
	Float bounds[2][3];
} Csg;

extern char	*CsgName();
extern Csg	*CsgCreate();
extern int	CsgIntersect(), CsgConvert();
extern void	CsgBounds();
extern int	FirstCsgGeom();
extern Methods	*CsgMethods();

#endif /* CSG_H */
