/*
 *  flame.h
 *
 *  Projektarbeit '94
 *
 *  written by Reto Mani
 *
 */


#ifndef FLAME_H
#define FLAME_H

#define GeomFlameCreate(s,p,l,v)   FlameCreate(s,p,l,v)

/* Flame definition */
typedef struct {
   Float          size;        /* size of flame */
   Float          x,y,z;   	 /* position of flame */
   Surface        *surface;    /* pointer to surface of object */
   Float          speed;
} Flame;


extern Geom     *FlameCreate();
extern Flame    *FlameObjCreate();
extern Methods  *FlameMethods();
extern int      FlameIntersect(), FlameEnter(), FlameNormal();
extern void     FlameBounds(), FlameUV(), FlameStats();
extern char     *FlameName();
int             FlameCalcColor();

#endif /* FLAME_H */






