/*
 * main.c
 *
 * Copyright (C) 1989, 1991, Craig E. Kolb
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 * main.c,v 4.1 1994/08/09 08:08:04 explorer Exp
 *
 * main.c,v
 * Revision 4.1  1994/08/09  08:08:04  explorer
 * Bump version to 4.1
 *
 * Revision 1.1.1.1  1994/08/08  04:52:29  explorer
 * Initial import.  This is a prerelease of 4.0.6enh3, or 4.1 possibly.
 *
 * Revision 4.0  91/07/17  14:55:35  kolb
 * Initial version.
 * 
 */

char rcsid[] = "main.c,v 4.1 1994/08/09 08:08:04 explorer Exp";

#include "rayshade.h"
#include "options.h"
#include "stats.h"
#include "viewing.h"
#include "picture.h"


int
main(argc, argv)
int argc;
char **argv;
{
	Float utime, stime;

	/*
 	 * Initialize variables, etc.
	 */
	RSInitialize(argc, argv);
	MethodsRegister();

	RSStartFrame(0);
	/*
 	 * Print more information than we'll ever need to know...
	 */
	if (Options.verbose) {
		extern Geom *World;
		/* World object info. */
		AggregatePrintInfo(World, Stats.fstats);
		/* Print info about rendering options and the like. */
		RSOptionsList();
	}
	/*
	 * Print preprocessing time.
	 */
	RSGetCpuTime(&utime, &stime);
	fprintf(Stats.fstats,"Preprocessing time:\t");
	fprintf(Stats.fstats,"%2.2fu  %2.2fs\n", utime, stime);
	fprintf(Stats.fstats,"Starting trace.\n");
	(void)fflush(Stats.fstats);
	/*
	 * Draw the image.
	 */
	Render();
	StatsPrint();
	return 0;
}
